Re: [PATCH v1] perf test: Be more tolerant of metricgroup failures

From: Namhyung Kim
Date: Thu Apr 04 2024 - 14:08:54 EST


Hi Ian,

On Wed, Apr 3, 2024 at 9:48 AM Ian Rogers <irogers@xxxxxxxxxx> wrote:
>
> Previously "set -e" meant any non-zero exit code from perf stat would
> cause a test failure. As a non-zero exit happens when there aren't
> sufficient permissions, check for this case and make the exit code
> 2/skip for it.
>
> Signed-off-by: Ian Rogers <irogers@xxxxxxxxxx>

Acked-by: Namhyung Kim <namhyung@xxxxxxxxxx>

Thanks,
Namhyung


> ---
> .../perf/tests/shell/stat_all_metricgroups.sh | 28 +++++++++++++++----
> 1 file changed, 22 insertions(+), 6 deletions(-)
>
> diff --git a/tools/perf/tests/shell/stat_all_metricgroups.sh b/tools/perf/tests/shell/stat_all_metricgroups.sh
> index 55ef9c9ded2d..d6db192b9f18 100755
> --- a/tools/perf/tests/shell/stat_all_metricgroups.sh
> +++ b/tools/perf/tests/shell/stat_all_metricgroups.sh
> @@ -1,9 +1,7 @@
> -#!/bin/sh
> +#!/bin/bash
> # perf all metricgroups test
> # SPDX-License-Identifier: GPL-2.0
>
> -set -e
> -
> ParanoidAndNotRoot()
> {
> [ "$(id -u)" != 0 ] && [ "$(cat /proc/sys/kernel/perf_event_paranoid)" -gt $1 ]
> @@ -14,11 +12,29 @@ if ParanoidAndNotRoot 0
> then
> system_wide_flag=""
> fi
> -
> +err=0
> for m in $(perf list --raw-dump metricgroups)
> do
> echo "Testing $m"
> - perf stat -M "$m" $system_wide_flag sleep 0.01
> + result=$(perf stat -M "$m" $system_wide_flag sleep 0.01 2>&1)
> + result_err=$?
> + if [[ $result_err -gt 0 ]]
> + then
> + if [[ "$result" =~ \
> + "Access to performance monitoring and observability operations is limited" ]]
> + then
> + echo "Permission failure"
> + echo $result
> + if [[ $err -eq 0 ]]
> + then
> + err=2 # Skip
> + fi
> + else
> + echo "Metric group $m failed"
> + echo $result
> + err=1 # Fail
> + fi
> + fi
> done
>
> -exit 0
> +exit $err
> --
> 2.44.0.478.gd926399ef9-goog
>